from Tkinter import *
from math import *
class Clock(Toplevel):
    def __init__(self, client=None, transient=1):
        Toplevel.__init__(self)
        self.title("Dawn time")

#        if transient:
#            self.transient(client.gui)

        canvas = Canvas(master=self,width=150,height=150)
        self.canvas = canvas
        canvas.pack(side=TOP, expand=YES, fill=BOTH)
        #canvas.configure(background = "grey")

        face = canvas.create_oval(5,5,145,145)
        canvas.itemconfigure(face, fill="white")

        r1 = 60
        r2 = 66
        
        for i in range(60):
            canvas.create_line(75+r1*sin(pi*i/30),75+r1*cos(pi*i/30),
                               75+r2*sin(pi*i/30),75+r2*cos(pi*i/30))

        r1 = 55
        r2 = 66
        for i in range(12):
            l = canvas.create_line(75+r1*sin(pi*i/6),75+r1*cos(pi*i/6),
                                   75+r2*sin(pi*i/6),75+r2*cos(pi*i/6))
            canvas.itemconfigure(l, width =2)
        
        rim = canvas.create_oval( 5, 5, 145, 145)
        canvas.itemconfigure(rim, width=10 , outline="brown")

        hour = canvas.create_line(75,75, 75, 35)
        canvas.itemconfigure(hour, width=10 , arrow =LAST, capstyle=ROUND)
        self.hour = hour

        min = canvas.create_line(75,75, 140, 75)
        canvas.itemconfigure(min, width=4 , arrow =LAST, fill="gray")
        self.min = min

        c = canvas.create_oval ( 70, 70, 80, 80)
        canvas.itemconfigure(c, fill = "black")


        self.hours = 2
        self.minutes = 0
        self.set_time(2,0)
        self.after(1000, self.advance)
        
    def set_time(self,hours,minutes):
        self.hours = hours
        self.minutes = minutes
        h = hours+minutes/60.0
        self.canvas.coords(self.hour, 75,75, 75+40*sin(pi*h/6),75-40*cos(pi*h/6))
        self.canvas.coords(self.min,  75,75, 75+60*sin(pi*minutes/30),75-60*cos(pi*minutes/30))


    def adjust_after(self, hour):
        if self.hours < hour:
            self.set_time(hour, 0)
        
    def advance(self):
        self.minutes = self.minutes + 1
        if (self.minutes >= 60):
            self.minutes = 0
            self.hours = self.hours+1
            if (self.hours > 12):
                self.hours = 1
        self.set_time(self.hours, self.minutes)
        self.after(1050, self.advance)
        
if __name__=="__main__":
    root = Tk()
    root.withdraw()
    c = Clock()
    mainloop()
