
from Tkinter import *
import string



class MsgComposer(Toplevel):
    def __init__(self, client, type="note"):
        Toplevel.__init__(self)
        self.client = client
        self.mtype = type
        self.title("composing "+type)
        f = Frame(self,relief=SUNKEN)
        f.pack(side=TOP)
        
        Label(f,text="to:").grid(row=0,sticky=E)
        self.to = StringVar()
        e = Entry(f,width=40,textvariable=self.to)
        e.grid(row=0,column=1,sticky=W)

        Label(f,text="subject:").grid(row=1,sticky=E)
        self.subject = StringVar()
        e = Entry(f,width=60,textvariable=self.subject)
        e.grid(row=1,column=1,sticky=W)

        tf = Frame(f)

        t = Text(tf,width=75,height=30)
        self.text = t
        t.pack(side=LEFT)
        s = Scrollbar(tf, command= t.yview)
        s.pack(side=RIGHT,fill=Y)
        t.configure(yscrollcommand=s.set)
        t.configure(wrap=WORD)
        tf.grid(row=2,column=0,columnspan=2)
        

        f = Frame(self, relief=SUNKEN,borderwidth=3)
        f.pack(side=TOP,fill=X)

        b=Button(f, text="Cancel", command = self.cancel)
        b.pack(side=RIGHT)
        b=Button(f, text="Send", command=self.send)
        b.pack(side=RIGHT)
        
    def cancel(self):
        self.destroy()

    def send(self):
        to = self.to.get()
        if len(string.strip(to))<1:
            showinfo("Info", "You have to enter an adress.")
            return
        
        subject = self.subject.get()
        if len(string.strip(subject))<1:
            showinfo("Info", "You have to enter a subject.")
            return

        text = self.text.get(1.0,END)
        if len(string.strip(text))<1:
            showinfo("Info", "You should write something in your "+self.mtype+".")
            return

        self.client.send(self.mtype+" to "+to)
        self.client.send(self.mtype+" subject "+subject)
        for l in string.split(text,"\n"):
            self.client.send(self.mtype+" + #n"+l)
        self.client.send(self.mtype+" post")
        self.destroy()

class MsgComposerScroll(Toplevel):
    def __init__(self, client):
        Toplevel.__init__(self)
        self.client = client
        self.title("writing scroll")
        f = Frame(self,relief=SUNKEN)
        f.pack(side=TOP)
        

        Label(f,text="subject:").grid(row=0,sticky=E)
        self.subject = StringVar()
        e = Entry(f,width=60,textvariable=self.subject)
        e.grid(row=0,column=1,sticky=W)

        tf = Frame(f)

        t = Text(tf,width=75,height=30)
        self.text = t
        t.pack(side=LEFT)
        s = Scrollbar(tf, command= t.yview)
        s.pack(side=RIGHT,fill=Y)
        t.configure(yscrollcommand=s.set)
        t.configure(wrap=WORD)
        tf.grid(row=1,column=0,columnspan=2)
        

        f = Frame(self, relief=SUNKEN,borderwidth=3)
        f.pack(side=TOP,fill=X)

        b=Button(f, text="Cancel", command = self.cancel)
        b.pack(side=RIGHT)
        b=Button(f, text="Send", command=self.send)
        b.pack(side=RIGHT)
        
    def cancel(self):
        self.destroy()

    def send(self):
        
        subject = self.subject.get()
        if len(string.strip(subject))<1:
            showinfo("Info", "You have to enter a subject.")
            return

        text = self.text.get(1.0,END)
        if len(string.strip(text))<1:
            showinfo("Info", "You should write something in your scroll.")
            return


        self.client.send("write scroll "+subject)
        for l in string.split(text,"\n"):
            self.client.send("write scroll #n"+l)
        self.destroy()
