#  A mud client for
#  Dawn of the Ages  http://dawn.netcologne.de
#
#  Copyright (C) 2001,2002 Peter Herth <p.herth@uni-koeln.de>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

import Term
import re

from Tkinter import *


class Talker(Toplevel):
    def __init__(self, client, talkto):
        Toplevel.__init__(self)
        self.title("Talk to "+talkto)
        self.client = client
        self.talkto = talkto

        term = Term.TermWindow(self,width=40,height=10)
        self.term = term

        self.entry = Term.HistoryEntry(self,output=self.output,toscroll=self.term.text,client=self.client)
        self.entry.set_enterfun(self.enter_fun)
        term.pack(side=TOP,expand=YES,fill=BOTH)        
        self.entry.pack(side=BOTTOM,expand=NO,fill=X)
        opts = re.MULTILINE|re.IGNORECASE
        self.gag1 = client.make_gag("^(.*"+talkto+".*tells you.*)$",self,"$1", opts)
        self.gag2 = client.make_gag("^(.*You tell.*"+talkto+".*)$",self,"$1", opts)

        client.add_gag(self.gag1)
        client.add_gag(self.gag2)

        self.protocol("WM_DELETE_WINDOW", self.do_quit)


    def enter_fun(self, text):
        self.client.process_command("tell "+self.talkto+" "+text)

    def output(self, text):
        self.term.append(text)

    def do_quit(self):
        self.client.remove_gag(self.gag1)
        self.client.remove_gag(self.gag2)
        self.withdraw()
        
